"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("@rmwc/base");
var icon_button_1 = require("@material/icon-button");
var react_1 = require("react");
exports.useIconButtonFoundation = function (props) {
    var _a = base_1.useFoundation({
        props: props,
        elements: { rootEl: true },
        foundation: function (_a) {
            var rootEl = _a.rootEl, emit = _a.emit;
            return new icon_button_1.MDCIconButtonToggleFoundation({
                addClass: function (className) { return rootEl.addClass(className); },
                removeClass: function (className) { return rootEl.removeClass(className); },
                hasClass: function (className) { return rootEl.hasClass(className); },
                setAttr: function (attrName, attrValue) {
                    return rootEl.setProp(attrName, attrValue);
                },
                notifyChange: function (evtData) { return emit('onChange', evtData); }
            });
        }
    }), foundation = _a.foundation, elements = __rest(_a, ["foundation"]);
    var rootEl = elements.rootEl;
    var isOn = props.checked !== undefined ? props.checked : foundation.isOn();
    react_1.useEffect(function () {
        if (isOn !== foundation.isOn()) {
            foundation.toggle(isOn);
        }
    }, [foundation, isOn]);
    var handleClick = function (evt) {
        var _a, _b;
        (_b = (_a = props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a, evt);
        foundation.handleClick();
    };
    rootEl.setProp('onClick', handleClick, true);
    return __assign({ isOn: isOn, foundation: foundation }, elements);
};
