"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var base_1 = require("@rmwc/base");
var icon_1 = require("@rmwc/icon");
var ripple_1 = require("@rmwc/ripple");
var foundation_1 = require("./foundation");
/** An IconButton component that can also be used as a toggle. */
exports.IconButton = React.forwardRef(function IconButton(_a, ref) {
    var rest = __rest(_a, []);
    if (rest.onIcon) {
        return React.createElement(IconButtonToggle, __assign({}, rest, { ref: ref }));
    }
    return React.createElement(IconButtonRoot, __assign({ "aria-hidden": "true", tag: "button" }, rest, { ref: ref }));
});
exports.IconButton.displayName = 'IconButton';
var IconButtonToggle = React.forwardRef(function IconButtonToggle(props, ref) {
    var icon = props.icon, onIcon = props.onIcon, rest = __rest(props, ["icon", "onIcon"]);
    var _a = foundation_1.useIconButtonFoundation(props), isOn = _a.isOn, rootEl = _a.rootEl;
    return (React.createElement(IconButtonToggleRoot, __assign({ "aria-pressed": isOn, "aria-hidden": "true" }, rootEl.props(rest), { tag: "button", ref: ref }),
        React.createElement(IconButtonIcon, { icon: icon }),
        React.createElement(IconButtonIcon, { icon: onIcon, on: true })));
});
/*********************************************************************
 * Bits
 *********************************************************************/
var IconButtonRoot = ripple_1.withRipple({
    surface: false,
    unbounded: true
})(React.forwardRef(function IconButtonRoot(props, ref) {
    var checked = props.checked, rest = __rest(props, ["checked"]);
    var className = base_1.useClassNames(props, [
        'mdc-icon-button',
        {
            'mdc-icon-button--on': checked
        }
    ]);
    return (React.createElement(icon_1.Icon, __assign({ role: "button", tabIndex: 0 }, rest, { className: className, ref: ref })));
}));
IconButtonRoot.displayName = 'IconButtonRoot';
var IconButtonToggleRoot = ripple_1.withRipple({
    surface: false,
    unbounded: true
})(React.forwardRef(function IconButtonToggleRoot(props, ref) {
    var checked = props.checked, rest = __rest(props, ["checked"]);
    var className = base_1.useClassNames(props, [
        'mdc-icon-button',
        {
            'mdc-icon-button--on': checked
        }
    ]);
    return (React.createElement(base_1.Tag, __assign({ tag: "button", role: "button", tabIndex: 0 }, rest, { className: className, ref: ref })));
}));
IconButtonToggleRoot.displayName = 'IconButtonToggleRoot';
var IconButtonIcon = React.memo(function IconButtonIcon(props) {
    var on = props.on, rest = __rest(props, ["on"]);
    var className = base_1.useClassNames(props, [
        'mdc-icon-button__icon',
        {
            'mdc-icon-button__icon--on': props.on
        }
    ]);
    return React.createElement(icon_1.Icon, __assign({}, rest, { className: className }));
});
IconButtonIcon.displayName = 'IconButtonIcon';
